local class

local pname = UnitName("player")
local guid = UnitGUID("player")

function GHI_GUID()
	if class then
		return class;
	end
	class = GHClass("GHI_GUID");
	
	local val2,StringHash,ToHex;
	
		
	StringHash = function(text)---takes text,gotten from wowwiki, does work with hex numbers!
      local counter = 1
     local len = string.len(text)
      for i = 1, len, 3 do 
      counter = math.fmod(counter*8161, 4294967279) +  -- 2^32 - 17: Prime!
      (string.byte(text,i)*16776193) +
      ((string.byte(text,i+1) or (len-i+256))*8372226) +
      ((string.byte(text,i+2) or (len-i+256))*3932164)
      end
      return math.fmod(counter, 4294967291) -- 2^32 - 5: Prime (and different from the prime in the loop)
	end
	
	ToHex = function(v)
	return string.format("%f",v)--string.format("%02x",StringHash(v))
	end
     
	class.MakeGUID = function()
	  local hashGUID = ToHex(StringHash(guid)) --hash the name then hex it.
	   --the player GUID is already in hex but we hex it again to make it SMALLER
	 --as player GUID is constant it will be the same hext each time
	 --OPTIONAL IDEA:Could add one more hex code based on player name?
	 --local hashName  = ToHex(pname)
	 
	  local hashTime = ToHex(time()-123456)
	  --hex based on time, this changes CONSTANTLY
	 
	 local ghGUID = hashGUID.."_"..hashTime;
	 --if optinal idea used would be
	 --local hashGUID.."_"..hashName.."_"..hashTime
	 
	 
	 return ghGUID;
		 
	end

	
	val2 = 0;
	--StringHash(val1);
	
	return class;
end


