﻿function GHI_ItemInfo()
	local class = GHClass("GHI_ItemInfo");
	
	local guid, name, itemType, quality, white1, white2, comment, icon, useText, stackSize, version, creatorName, creatorGuid, rawData;
	
	InitializeItemData = function()
		guid			= 0;
		name			= '';
		itemType 		= '';
		quality 		= 1;
		white1 			= '';
		white2 			= '';
		comment 		= '';
		icon 			= 'Interface\\Icons\\INV_Misc_QuestionMark';
		useText 		= '';
		stackSize		= 1;
		version 		= 0;
		creatorName		= '';
		creatorGuid		= '';
		rawData 		= nil;
	end;
	
	class.ReturnItemData = function()
		return {
			guid 		= guid,
			name 		= name,
			itemType 	= itemType,
			quality 	= quality,
			white1 	    = white1,
			white2 	    = white2,
			comment 	= comment,
			icon 		= icon,
			useTex 	    = useText,
			stackSize 	= stackSize,
			version 	= version,
			creatorName = creatorName,
			creatorGuid = creatorGuid,
			rawData 	= rawData
		}
	end;
	
	InitializeItemData();
	
	return class;
	
end